package org.springblade.estate.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.entity.BillsItem;
import org.springblade.estate.service.IBillsItemService;
import org.springblade.estate.vo.BillsItemVO;
import org.springblade.estate.wrapper.BillsItemWrapper;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;

import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-04-23
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/billsitem")

public class BillsItemClient implements IBillsItemClient {

    private final IBillsItemService billsItemService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public BillsItemVO detail(@SpringQueryMap BillsItem billsItem) {
        BillsItem detail = billsItemService.getOne(Condition.getQueryWrapper(billsItem));
        return BillsItemWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<BillsItemVO> list(@SpringQueryMap BillsItem billsItem) {
        return BillsItemWrapper.build().listVO(billsItemService.list(Condition.getQueryWrapper(billsItem)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody BillsItem billsItem) {
        return billsItemService.save(billsItem);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody BillsItem billsItem) {
        return billsItemService.updateById(billsItem);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody BillsItem billsItem) {
        return billsItemService.saveOrUpdate(billsItem);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return billsItemService.deleteLogic(Func.toLongList(ids));
        }


}
